import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.lang.Math;
/**
 * Write a description of class Bishop here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bishop extends Piece
{
    /**
     * Act - do whatever the Bishop wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public static int amount = 0;
    public Bishop(String value) {
        team = value;
    }
    public void addedToWorld(World world)
    {
        amount++;
        setImage(team+"_"+"bishop.png");
    }
    public boolean isValidMove(int x,int y)
    {
        int nx = Math.abs(x-getX());
        int ny = Math.abs(y-getY());
        if(nx != ny) return false;
        for(int i=0; i<nx; i++)
        {
            if(i == nx) return true;
            if(PieceExist(getX()+i, getY()+i) && getX()<x && getY()<y) return false;
            if(PieceExist(getX()-i, getY()-i)) return false;
            if(PieceExist(getX()-i, getY()+i)) return false;
            if(PieceExist(getX()+i, getY()-i)) return false;
        }
        return true;
    }
    public void act() 
    {
        if(selected)
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            if(mouse != null)
                if(mouse.getButton() == 1)
                {
                    int x = mouse.getX();
                    int y = mouse.getY();
                    if(isValidMove(x,y)) {
                        moveTo(x,y);
                        selected = false;
                    }
            }
        }
        if(Blue.turn == team)checkMouse();
    } 
}
