import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Piece here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class Piece extends Actor
{
    /**
     * Act - do whatever the Piece wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public boolean selected;
    public String team = "orange";

    public void refreshBoard()
    {
        getWorld().removeObjects(getWorld().getObjects(Tile.class));
        for(int x = 0; x<8; x++)
        {
            for(int y = 0; y<8; y++)
            {
                if(getWorld().getObjectsAt(x, y, Piece.class).size() < 1 || isEnemy(getWorld(),x, y))
                    getWorld().addObject(new Tile(), x, y);
            }
        }
    }

    public void checkMouse()
    {
        if (this.team == Blue.turn) {
            if (Greenfoot.mouseClicked(null)) {
                if (Greenfoot.mouseClicked(this) && !selected) {
                    selected = true;
                    Tile.selected = true;
                }
                if (Greenfoot.mouseClicked(null) && selected && Greenfoot.getMouseInfo().getActor() != this) {
                    selected = false;
                    Tile.unSelect(getWorld());
                }
            }
        } else selected = false;
    }

    public void endTurn()
    {
        if(Blue.turn == "blue")
            Blue.turn = "orange";
        else
            Blue.turn = "blue"; 
    }

    public boolean isEnemy(Piece it)
    {
        if(it.team != team)
        {
            return true;
        }
        return false;
    }

    public boolean isEnemy(int x, int y)
    {
        List list =  getWorld().getObjectsAt(x, y, Piece.class);
        for(int c = 0; c < list.size(); c++)
        {
            return isEnemy((Piece)list.get(c));
        }
        return false;
    }

    public static boolean isEnemy(World world, int x, int y)
    {
        List list =  world.getObjectsAt(x, y, Piece.class);
        for(int c = 0; c < list.size(); c++)
        {
            Piece it = (Piece)list.get(c);
            if(it.team != Blue.turn)
            {
                return true;
            }
        }
        return false;
    }

    public abstract boolean isValidMove(int x, int y);

    public boolean PieceExist(int x, int y)
    {

        List list =  getWorld().getObjectsAt(x, y, Piece.class);
        if(list.size() > 0) return true;
        return false;
    }

    public boolean PieceExist(Piece piece, int x, int y)
    {

        List list =  getWorld().getObjectsAt(x, y, Piece.class);
        if(list.size() > 0)
            if(list.get(0) != piece) return true;
        return false;
    }

    public void moveTo(int x, int y)
    {
        boolean allowed = true;
        World world = getWorld();
        List list =  world.getObjectsAt(x, y, Piece.class);
        for(int c = 0; c < list.size(); c++)
        {
            if(!isEnemy( (Piece) list.get(c)))
            {
                allowed = false;
            } else
            {
                getWorld().removeObject((Actor)list.get(c));
            }
        }
        if(allowed){
            setLocation(x, y);
            endTurn();
            refreshBoard();
        }
    }

    //Simple math for validity.
    public boolean isAdjacent(int x, int y, int x1, int y1, int maxblocks)
    {
        if(((x1 - x <= maxblocks)&&(x1 - x > 0)) || (x - x1 <= maxblocks)&&(x - x1 > 0) || (y1 - y <= maxblocks)&&(y1 - y > 0) || (y - y1 <= maxblocks)&&(y - y1 > 0))
            return true;
        else
            return false;
    }

    public boolean isDiagonal(int x, int y, int x1, int y1, int maxblocks)
    {
        int x2 = x-x1;
        int y2 = y-y1;
        //if(x2==y2 &&  )
        return true;
        //else
    } 

}
