import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.lang.Math;
/**
 * Write a description of class Rook here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Rook extends Piece
{
    /**
     * Act - do whatever the Rook wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public static int amount = 0;
    public Rook(String value) {
        team = value;
    }

    public void addedToWorld(World world)
    {
        amount++;
        setImage(team+"_"+"rook.png");
    }

    public boolean isValidMove(int x,int y)
    {
        if(x>getX() && y==getY())
        {
            for(int nx=0; nx<(x-getX());nx++)
                if(PieceExist(nx-1, y)) return false;
            return true;
        }
        if(x<getX() && y==getY()) 
        {
            for(int nx=0; nx<(getX()-x);nx++)
                if(PieceExist(nx+1, y)) return false;
            return true;
        }
        if(x==getX() && y>getY()) 
        {
            for(int ny=0; ny<(y-getY());ny++)
                if(PieceExist(x, ny-1)) return false;
            return true;
        }
        if(x==getX() && y<getY()) 
        {
            for(int ny=0; ny<(getY()-y);ny++)
                if(PieceExist(x, ny+1)) return false;
            return true;
        }
        return false;
    }

    public void act() 
    {
        if(selected)
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            if(mouse != null)
                if(mouse.getButton() == 1)
                {
                    int x = mouse.getX();
                    int y = mouse.getY();
                    if(isValidMove(x,y)) {
                        moveTo(x,y);
                        selected = false;
                    }
            }
        }
        if(Blue.turn == team)checkMouse();
    }    
}
