import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Board here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Board extends World
{

    /**
     * Constructor for objects of class Board.
     * 
     */
    public Board()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(8, 8, 50); 
        addObject(new Blue(),-1,0);
        addObject(new Orange(),-1,0);
        refreshBoard();
        
    }
    public King isKing(int x, int y)
    {
        List kings = getObjects(King.class);
        for(int i=0; i<kings.size(); i++){
            King king = (King) kings.get(i);
            if(king.getX() == x && king.getY() == y && (king.team != Blue.turn))
                return king;
        }
        return null;
    }
    public void refreshBoard()
    {
        removeObjects(getObjects(Tile.class));
        for(int x = 0; x<8; x++)
        {
            for(int y = 0; y<8; y++)
            {
                if(getObjectsAt(x, y, Piece.class).size() < 1 || Piece.isEnemy(this, x, y))
                    addObject(new Tile(), x, y);
            }
        }
    }

}
