import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.lang.Math;
/**
 * Write a description of class Pawn here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Pawn extends Piece
{
    /**
     * Act - do whatever the Pawn wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public boolean moved = false;
    public Pawn(String value) {
        team = value;
    }

    public void addedToWorld(World world)
    {
        setImage(team+"_"+"pawn.png");
    }

    public boolean isValidMove(int x,int y)
    {
        
        if(isEnemy(x,y)) {
            if(team == "blue" ? getY()-1==y : getY()+1==y)
                if(Math.abs(getX()-x)==1)
                    return true;
            return false;
        }
        if(team == "blue" ? y > getY() : y < getY()) return false;
        if(x!=getX())
            return false;
        if((y-getY()==1) || (y-getY()==-1))
        {

            return true;
        }
        if((y-getY()==2) || (y-getY()==-2))
        {
            if(!moved)
                return true;
        }
        return false;
    }

    public void act() 
    {
        if(selected)
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            if(mouse != null)
                if(mouse.getButton() == 1)
                {
                    int x = mouse.getX();
                    int y = mouse.getY();
                    if(isValidMove(x,y)) {
                        moved = true;
                        moveTo(x,y);
                        refreshBoard();
                        selected = false;
                    }
            }
        }
        if(Blue.turn == team)checkMouse();
    }    
}
